Package org.codehaus.groovy.classgen.asm.sc

# Class StaticTypesUnaryExpressionHelper

java.lang.Object
org.codehaus.groovy.classgen.asm.UnaryExpressionHelper
org.codehaus.groovy.classgen.asm.sc.StaticTypesUnaryExpressionHelper

public class StaticTypesUnaryExpressionHelper extends UnaryExpressionHelper
An expression helper which generates optimized bytecode depending on the current type on top of the operand stack.

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.classgen.asm.UnaryExpressionHelper

  `controller`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StaticTypesUnaryExpressionHelper(WriterController controller)`
  Creates a unary-expression helper that emits primitive-specialized bytecode when possible.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `writeBitwiseNegate(BitwiseNegationExpression expression)`
  Generates bytecode for a bitwise negation expression.
  `void`
  `writeNotExpression(NotExpression expression)`
  Generates bytecode for a logical not expression.
  `void`
  `writeUnaryMinus(UnaryMinusExpression expression)`
  Generates bytecode for a unary minus expression.
  `void`
  `writeUnaryPlus(UnaryPlusExpression expression)`
  Generates bytecode for a unary plus expression.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### StaticTypesUnaryExpressionHelper

    public StaticTypesUnaryExpressionHelper(WriterController controller)
    Creates a unary-expression helper that emits primitive-specialized bytecode when possible.

- ## Method Details

  - ### writeBitwiseNegate

    public void writeBitwiseNegate(BitwiseNegationExpression expression)
    Generates bytecode for a bitwise negation expression.
    Overrides:
      `writeBitwiseNegate` in class `UnaryExpressionHelper`
    Parameters:
      `expression` - the bitwise negation expression

  - ### writeNotExpression

    public void writeNotExpression(NotExpression expression)
    Generates bytecode for a logical not expression.
    Overrides:
      `writeNotExpression` in class `UnaryExpressionHelper`
    Parameters:
      `expression` - the not expression

  - ### writeUnaryMinus

    public void writeUnaryMinus(UnaryMinusExpression expression)
    Generates bytecode for a unary minus expression.
    Overrides:
      `writeUnaryMinus` in class `UnaryExpressionHelper`
    Parameters:
      `expression` - the unary minus expression

  - ### writeUnaryPlus

    public void writeUnaryPlus(UnaryPlusExpression expression)
    Generates bytecode for a unary plus expression.
    Overrides:
      `writeUnaryPlus` in class `UnaryExpressionHelper`
    Parameters:
      `expression` - the unary plus expression